#include "tree.h"
#include <assert.h>

#include <iostream>
using namespace std;

tree::tree() { root = 0; }

tree::node::node(int data) {
  _data = data; _left = _right = 0;
}

void tree::insert(int data) { insert(data, root); }
void tree::insert(int data, node * & root) {
  if (root == 0) root = new node(data);
  else if (data < root->_data) insert(data, root->_left);
  else if (data > root->_data) insert(data, root->_right);
  // else return;
  else cout << data << " already in!" << endl;
}

void tree::print() { print(root, 0); }
void tree::print(node * root, int level) {
  if (root != 0) {
    print(root->_right, level+1);
    for (int i=0; i<level; i++) cout << " -";
    cout << root->_data << endl;
    print(root->_left, level+1);
  }
}
